unit PWGen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmPWGenerate = class(TForm)
    edPassword: TEdit;
    btnGenerate: TButton;
    gbAvailChars: TGroupBox;
    cbAZ: TCheckBox;
    cbAZSmall: TCheckBox;
    cb09: TCheckBox;
    cbOther: TCheckBox;
    edOther: TEdit;
    lblKey: TLabel;
    edKey: TEdit;
    lblSource: TLabel;
    edSource: TEdit;
    bvlGenerator: TBevel;
    procedure btnGenerateClick(Sender: TObject);
  private
    { Private declarations }
    function GetChar(chSource: Char; Dictionary: string; intShift: Integer): Char;
  public
    { Public declarations }
  end;

var
  frmPWGenerate: TfrmPWGenerate;

implementation

{$R *.DFM}

function TfrmPWGenerate.GetChar(chSource: Char; Dictionary: string; intShift: Integer): Char;
var
  i, j: Integer;
begin
  Result := chSource;
  i := 1;
  j := Length(Dictionary);
  while (i <= j) do
    if (Dictionary[i] = chSource) then
    begin
      Result := Dictionary[(i + intShift) mod j];
      exit
    end
    else
      Inc(i);
end;

procedure TfrmPWGenerate.btnGenerateClick(Sender: TObject);
var
  i, j, intLenSource: Integer;
  strDictionary: string;
begin
  if edSource.Text = '' then
  begin
    MessageDlg('You must define the SOURCE string for encryption', mtError, [mbOk], 0);
    exit;
  end;

  if StrToIntDef(edKey.Text, -1) = -1 then
  begin
    MessageDlg('You must define the KEY number for encryption', mtError, [mbOk], 0);
    exit;
  end;

  if cbAZ.Checked then
    strDictionary := 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
  else
    strDictionary := '';
  if cbAZSmall.Checked then
    strDictionary := strDictionary + 'abcdefghijklmnopqrstuvwxyz';
  if cb09.Checked then
    strDictionary := strDictionary + '0123456789';
  if cbOther.Checked then
    strDictionary := strDictionary + edOther.Text;
  if strDictionary = '' then
  begin
    MessageDlg('You must define the DICTIONARY string for encryption', mtError, [mbOk], 0);
    exit;
  end;

  edPassword.Text := '';
  intLenSource := Length(edSource.Text);
  j := 1;
  for i := 1 to intLenSource do
  begin
    edPassword.Text := edPassword.Text + GetChar(edSource.Text[i], strDictionary, StrToInt(edKey.Text{[j]}));
    Inc(j);
    if (j > Length(edKey.Text)) then
      j := 1;
  end;
end;

end.
